Package org.mariadb.jdbc

## Class ParameterMetaData

- java.lang.Object
- - org.mariadb.jdbc.ParameterMetaData

All Implemented Interfaces:
  `ParameterMetaData`, `Wrapper`

    public class ParameterMetaData
    extends Object
    implements ParameterMetaData

### Field Summary

### Fields inherited from interface java.sql.ParameterMetaData

`parameterModeIn, parameterModeInOut, parameterModeOut, parameterModeUnknown, parameterNoNulls, parameterNullable, parameterNullableUnknown`

### Constructor Summary

Constructors
`ParameterMetaData​(ExceptionFactory exceptionFactory, ColumnDefinitionPacket[] params)`

### Method Summary

All Methods Instance Methods Concrete Methods
`String` `getParameterClassName​(int idx)` Retrieves the fully-qualified name of the Java class whose instances should be passed to the method `PreparedStatement.setObject`.
`int` `getParameterCount()` Retrieves the number of parameters in the `PreparedStatement` object for which this `ParameterMetaData` object contains information.
`int` `getParameterMode​(int idx)` Retrieves the designated parameter's mode.
`int` `getParameterType​(int param)` Retrieves the designated parameter's SQL type.
`String` `getParameterTypeName​(int idx)` Retrieves the designated parameter's database-specific type name.
`int` `getPrecision​(int idx)` Retrieves the designated parameter's specified column size.
`int` `getScale​(int idx)` Retrieves the designated parameter's number of digits to right of the decimal point.
`int` `isNullable​(int idx)` Retrieves whether null values are allowed in the designated parameter.
`boolean` `isSigned​(int idx)` Retrieves whether values for the designated parameter can be signed numbers.
`boolean` `isWrapperFor​(Class<?> iface)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
`<T> T` `unwrap​(Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ParameterMetaData

    public ParameterMetaData​(ExceptionFactory exceptionFactory,
                             ColumnDefinitionPacket[] params)

### Method Detail

#### getParameterCount

    public int getParameterCount()

Retrieves the number of parameters in the `PreparedStatement` object for which this `ParameterMetaData` object contains information.

Specified by:
  `getParameterCount` in interface `ParameterMetaData`
Returns:
  the number of parameters

#### isNullable

    public int isNullable​(int idx)
                   throws SQLException

Retrieves whether null values are allowed in the designated parameter.

Specified by:
  `isNullable` in interface `ParameterMetaData`
Parameters:
  `idx` - the first parameter is 1, the second is 2, ...
Returns:
  the nullability status of the given parameter; one of `ParameterMetaData.parameterNoNulls`, `ParameterMetaData.parameterNullable`
Throws:
  `SQLException` - if wrong index

#### isSigned

    public boolean isSigned​(int idx)
                     throws SQLException

Retrieves whether values for the designated parameter can be signed numbers.

Specified by:
  `isSigned` in interface `ParameterMetaData`
Parameters:
  `idx` - the first parameter is 1, the second is 2, ...
Returns:
  `true` if so; `false` otherwise
Throws:
  `SQLException` - if wrong index

#### getPrecision

    public int getPrecision​(int idx)
                     throws SQLException

Retrieves the designated parameter's specified column size.

The returned value represents the maximum column size for the given parameter. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. 0 is returned for data types where the column size is not applicable.

Specified by:
  `getPrecision` in interface `ParameterMetaData`
Parameters:
  `idx` - the first parameter is 1, the second is 2, ...
Returns:
  precision
Throws:
  `SQLException` - if wrong index

#### getScale

    public int getScale​(int idx)
                 throws SQLException

Retrieves the designated parameter's number of digits to right of the decimal point. 0 is returned for data types where the scale is not applicable. Parameter type are not sent by server. See * https://jira.mariadb.org/browse/CONJ-568 and https://jira.mariadb.org/browse/MDEV-15031

Specified by:
  `getScale` in interface `ParameterMetaData`
Parameters:
  `idx` - the first parameter is 1, the second is 2, ...
Returns:
  scale
Throws:
  `SQLException` - if a database access error occurs

#### getParameterType

    public int getParameterType​(int param)
                         throws SQLException

Retrieves the designated parameter's SQL type. Parameter type are not sent by server. See https://jira.mariadb.org/browse/CONJ-568 and https://jira.mariadb.org/browse/MDEV-15031

Specified by:
  `getParameterType` in interface `ParameterMetaData`
Parameters:
  `param` - the first parameter is 1, the second is 2, ...
Returns:
  SQL types from `java.sql.Types`
Throws:
  `SQLException` - because not supported

#### getParameterTypeName

    public String getParameterTypeName​(int idx)
                                throws SQLException

Retrieves the designated parameter's database-specific type name.

Specified by:
  `getParameterTypeName` in interface `ParameterMetaData`
Parameters:
  `idx` - the first parameter is 1, the second is 2, ...
Returns:
  type the name used by the database. If the parameter type is a user-defined type, then a fully-qualified type name is returned.
Throws:
  `SQLException` - if wrong index

#### getParameterClassName

    public String getParameterClassName​(int idx)
                                 throws SQLException

Retrieves the fully-qualified name of the Java class whose instances should be passed to the method `PreparedStatement.setObject`.

Specified by:
  `getParameterClassName` in interface `ParameterMetaData`
Parameters:
  `idx` - the first parameter is 1, the second is 2, ...
Returns:
  the fully-qualified name of the class in the Java programming language that would be used by the method `PreparedStatement.setObject` to set the value in the specified parameter. This is the class name used for custom mapping.
Throws:
  `SQLException` - if wrong index

#### getParameterMode

    public int getParameterMode​(int idx)
                         throws SQLException

Retrieves the designated parameter's mode.

Specified by:
  `getParameterMode` in interface `ParameterMetaData`
Parameters:
  `idx` - the first parameter is 1, the second is 2, ...
Returns:
  mode of the parameter; one of `ParameterMetaData.parameterModeIn`, `ParameterMetaData.parameterModeOut`, or `ParameterMetaData.parameterModeInOut` `ParameterMetaData.parameterModeUnknown`.
Throws:
  `SQLException`

#### unwrap

    public <T> T unwrap​(Class<T> iface)
                 throws SQLException

Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise, return the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.

Specified by:
  `unwrap` in interface `Wrapper`
Parameters:
  `iface` - A Class defining an interface that the result must implement.
Returns:
  an object that implements the interface. Maybe a proxy for the actual implementing object.
Throws:
  `SQLException` - If no object found that implements the interface

#### isWrapperFor

    public boolean isWrapperFor​(Class<?> iface)

Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.

Specified by:
  `isWrapperFor` in interface `Wrapper`
Parameters:
  `iface` - a Class defining an interface.
Returns:
  true if this implements the interface or directly or indirectly wraps an object that does.